unit World;

interface

uses
  Dialogs, Graphics;

type
  TWorld = class
  private
    Width, Height: Integer;
    LevelMap: array of array of Boolean;
  public
    constructor Create(AWidth, AHeight: Integer);
    destructor Destroy; override;
    function LoadMap(FileName: String): Integer;
    function IsAvailablePos(X, Y: Integer): Boolean;
  end;

implementation

{ TWorld }

constructor TWorld.Create(AWidth, AHeight: Integer);
begin
  try
    SetLength(LevelMap, AWidth, AHeight);
  except
    ShowMessage('Out of memory for World allocation!');
    Self := nil;
    Exit;
  end;
  Width := AWidth;
  Height := AHeight;
end;

destructor TWorld.Destroy;
begin
  SetLength(LevelMap, 0);
  LevelMap := nil;
  inherited Destroy;
end;

function TWorld.IsAvailablePos(X, Y: Integer): Boolean;
begin
  if (X < 0) or (X >= Width) or (Y < 0) or (Y >= Height) then
    Result := False
  else
    Result := not LevelMap[X, Y];
end;

function TWorld.LoadMap(FileName: String): Integer;
var
  I, J: Integer;
begin
  //LevelMap je samo maska koja oznacava kuda moze
  //igrac da se krece u nivou

  for I := 0 to Width - 1 do
    for J := 0 to Height - 1 do
      LevelMap[I, J] := (I = 0) or (I = Width - 1) or (J = 0) or (J = Height - 1);

  for I := 0 to 252 do
    for J := 0 to 192 do
      LevelMap[I, J] := True;
  Result := 1;
end;

end.
